/**
 @file EDController.h
 @brief EgyptDJ ~(-_-)~ 컨트롤러 헤더 파일
 
 Created by Hoppang on 08. 12. 20.
 */

#import <Cocoa/Cocoa.h>
#include </Developer/FMOD Programmers API Mac/api/inc/fmod.h>

@class EDView;
@class BMSFile;
@class EDModeManager;
@class PlayingMode;
@class MenuMode;

/**
 @brief 컨트롤러 인터페이스
 */
@interface EDController : NSObject {
	IBOutlet EDView *view;		///< 뷰 객체의 연결고리
	EDModeManager* modeManager;	///< 실행 모드 관리자
	NSTimer *timer;				///< 정확과 담쌓은 저질 타이머
	
	PlayingMode *playingMode;
	MenuMode *menuMode;
	CFAbsoluteTime startTime;	///< 플레이 시작시간. 없애자.
	BMSFile *bms;				///< BMS 파일 객체

	FMOD_SYSTEM *soundSystem;
}

@property(nonatomic, readonly) FMOD_SYSTEM *soundSystem;

- (void)run:(NSTimer *)aTimer;	///< 타이머 getter

@end
