/**
 @file EDView.m
 @brief EgyptDJ ~(-_-)~ 뷰 소스 파일
 
 Created by Hoppang on 08. 12. 20.
 */

#import "EDView.h"

@implementation EDView

/**
 @brief 화면 초기화
 @param frameRect 자동으로 전달되는 인자. 프레임 영역
 */
- (id)initWithFrame:(NSRect)frameRect
{
	
	NSLog(@"EDView initWithFrame:");
	self = [super initWithFrame:frameRect];
	tempContext = LoadSprite(@"/Users/hoppang/Downloads/sample.jpg");
	NSLog(@"LoadSprite-");

	// ImageRef 직접 뽑아서 그리기
	CGImageSourceRef source;
	source = CGImageSourceCreateWithURL((CFURLRef)[NSURL fileURLWithPath:@"/Users/hoppang/Downloads/sample.jpg"], NULL);
	spriteImage = CGImageSourceCreateImageAtIndex(source, 0, NULL);

	// 레이어 만들어서 그리기 - TODO: 레이어에 비트맵 이미지 넣기
	spriteLayer = CGLayerCreateWithContext(tempContext, CGSizeMake(64,64), NULL);
	spriteContext = CGLayerGetContext(spriteLayer);
	CGContextSetAlpha(spriteContext, 1);
	CGContextSetShadow(spriteContext, CGSizeMake(0, 128), 0.5);
	CGContextDrawImage(spriteContext, CGRectMake(0, 0, 128, 128), spriteImage);
	
	
	srand(time(NULL));
	return self;
}

- (void)dealloc
{
	[super dealloc];
}

/**
 @brief 화면 그리기 메서드
 @param rect 그릴 영역. 여기서는 항상 전체 영역을 전달한다.
 */
- (void)drawRect:(NSRect)rect 
{
	static double spritey = 0.0;
	if(spritey > 500) spritey = 0.0;
	spritey = spritey + 0.4;
	CGContextRef edContext = [[NSGraphicsContext currentContext] graphicsPort];

	CGContextSetRGBFillColor(edContext, 1, 1, 1, 1);
	CGContextFillRect(edContext, CGRectMake(0,0,800,600));
	CGContextDrawImage(edContext, CGRectMake(0, spritey, 128, 128), spriteImage);
}

/**
 @brief 주어진 경로의 그림파일을 읽어서 레이어로 만든다
 @param path 그림파일의 절대경로
 */
CGContextRef LoadSprite(NSString *path) 
{
	CGImageSourceRef imageSource;
	imageSource = CGImageSourceCreateWithURL((CFURLRef)[NSURL fileURLWithPath:path], NULL);
	CGImageRef imageref = CGImageSourceCreateImageAtIndex(imageSource, 0, NULL);
	assert(imageref);
	size_t width = CGImageGetWidth(imageref);
	size_t height = CGImageGetHeight(imageref);
	NSLog(@"width = %d", width);
	void *data = malloc(width*height*4);
	NSLog(@"size = %d", width*4*height);
	CGColorSpaceRef space = CGColorSpaceCreateWithName(kCGColorSpaceGenericRGB);
	CGContextRef context = CGBitmapContextCreate(data, width, height, 8, width*4, space, 
												kCGImageAlphaNoneSkipLast);
	assert(context);
	return context;
}

@end
